VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ISysTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Public Enum MouseEvent
    meMove = 512&
    meLeftDown = 513&
    meLeftUp = 514&
    meLeftDblClk = 515&
    meRightDown = 516&
    meRightUp = 517&
    meRightDblClk = 518&
    meMidDown = 519&
    meMidUp = 520&
    meMidDblClk = 521&
End Enum

Public Enum ButtonState
    bsDown = 1&
    bsUp = 2&
    bsDblClk = 4&
End Enum

Public Event MouseClick(ByVal mbButton As MouseButtonConstants, ByVal bsState As ButtonState)
Public Event MouseMove()

Private mblnInitialized     As Boolean
Private mlngHwnd            As Long
Private mlngHicon           As Long
Private mstrPopUpMessage    As String
Private mlngCallBackID      As Long
Private mlngPrevProcID      As Long
Private midIconData         As IconData

Public Property Let hWnd(ByVal lngHwnd As Long)
    mlngHwnd = lngHwnd
End Property

Public Property Get hWnd() As Long
    hWnd = mlngHwnd
End Property

Public Property Let hIcon(ByVal lngHicon As Long)
    mlngHicon = lngHicon
End Property

Public Property Get hIcon() As Long
    hIcon = mlngHicon
End Property

Public Property Let PopUpText(ByVal strPopUpText As String)
    mstrPopUpMessage = Replace(Left$(strPopUpText, 63), Chr(0), vbNullString) & Chr(0)
End Property

Public Property Get PopUpText() As String
    PopUpText = Replace(mstrPopUpMessage, Chr(0), vbNullString)
End Property

Public Function IconToTray(Optional ByVal lngHwnd As Long, Optional ByVal lngHicon As Long, Optional ByVal strPopUpText As String) As Boolean
    If mlngHwnd = 0 Then mlngHwnd = lngHwnd
    If mlngHwnd = 0 Then Exit Function
    If Not SetPrivateData(lngHicon, strPopUpText) Then Exit Function
    mblnInitialized = SubClass(mlngHwnd, saInit)
    If Not mblnInitialized Then Exit Function
    IconToTray = SysTrayProc(iaAdd, midIconData) = 1
End Function

Public Function IconFromTray() As Boolean
    If Not mblnInitialized Then Exit Function
    IconFromTray = SysTrayProc(iaDelete, midIconData) = 1
End Function

Public Function IconModifyTray(Optional ByVal lngHicon As Long, Optional ByVal strPopUpText As String) As Boolean
    If Not mblnInitialized Then Exit Function
    If Not SetPrivateData(lngHicon, strPopUpText) Then Exit Function
    IconModifyTray = SysTrayProc(iaModify, midIconData) = 1
End Function

Private Function SetPrivateData(Optional ByVal lngHicon As Long, Optional ByVal strPopUpText As String) As Boolean
    If lngHicon Then mlngHicon = lngHicon
    If Len(strPopUpText) Then mstrPopUpMessage = Replace(Left$(strPopUpText, 63), Chr(0), vbNullString) & Chr(0)
    If mlngHwnd = 0 Or mlngHicon = 0 Then Exit Function
    With midIconData
        .idCallBackID = CALLBACK_ID
        .idFlags = imIcon Or imHint Or imCallback
        .idHwnd = mlngHwnd
        .idIcon = mlngHicon
        .idID = APP_ID
        .idTip = mstrPopUpMessage
    End With
    SetPrivateData = True
End Function

Friend Sub ForwardEvent(ByVal meEvent As MouseEvent)
    Select Case meEvent
        Case meMove:        RaiseEvent MouseMove
        Case meLeftDblClk:  RaiseEvent MouseClick(vbLeftButton, bsDblClk)
        Case meLeftDown:    RaiseEvent MouseClick(vbLeftButton, bsDown)
        Case meLeftUp:      RaiseEvent MouseClick(vbLeftButton, bsUp)
        Case meRightDblClk: RaiseEvent MouseClick(vbRightButton, bsDblClk)
        Case meRightDown:   RaiseEvent MouseClick(vbRightButton, bsDown)
        Case meRightUp:     RaiseEvent MouseClick(vbRightButton, bsUp)
        Case meMidDblClk:   RaiseEvent MouseClick(vbMiddleButton, bsDblClk)
        Case meMidDown:     RaiseEvent MouseClick(vbMiddleButton, bsDown)
        Case meMidUp:       RaiseEvent MouseClick(vbMiddleButton, bsUp)
    End Select
End Sub

Private Sub Class_Initialize()
    If App.PrevInstance Then Exit Sub
    Set pobjSysTray = Me
End Sub

Private Sub Class_Terminate()
    SubClass mlngHwnd, saDestroy
    IconFromTray
    Set pobjSysTray = Nothing
End Sub
